VERSION 5.00
Begin VB.Form frmHistory 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Browser Session History"
   ClientHeight    =   3690
   ClientLeft      =   285
   ClientTop       =   570
   ClientWidth     =   7410
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3690
   ScaleWidth      =   7410
   StartUpPosition =   1  'CenterOwner
   Visible         =   0   'False
   Begin VB.PictureBox pic 
      Align           =   2  'Align Bottom
      BorderStyle     =   0  'None
      Height          =   480
      Left            =   0
      ScaleHeight     =   480
      ScaleWidth      =   7410
      TabIndex        =   1
      Top             =   3210
      Width           =   7410
      Begin VB.CommandButton cmdCancel 
         Cancel          =   -1  'True
         Caption         =   "Cancel"
         Height          =   375
         Left            =   4980
         TabIndex        =   3
         Top             =   60
         Width           =   1125
      End
      Begin VB.CommandButton cmdOK 
         Caption         =   "OK"
         Default         =   -1  'True
         Enabled         =   0   'False
         Height          =   375
         Left            =   6210
         TabIndex        =   2
         Top             =   60
         Width           =   1125
      End
      Begin VB.Label lblURL 
         Height          =   195
         Left            =   120
         TabIndex        =   4
         Top             =   150
         Width           =   4800
      End
   End
   Begin VB.ListBox lst 
      Height          =   300
      IntegralHeight  =   0   'False
      Left            =   240
      Sorted          =   -1  'True
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "frmHistory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Supporting ListBox form for program WbrFavs
' Maintains Browser History List items as Title & vbTab & URL
' NOTE: Form is loaded for life of WbrFavs program
'========================================================================
' Module-level Variables
Private mVertUsedArea As Long
Private MARGINx2 As Long
' Module-level Constants
Private Const MARGIN = 15
' WinAPI Declarations
Private Const LB_SETTABSTOPS = &H192
Private Const LB_SETHORIZONTALEXTENT = &H194
Private Const LB_SETCURSEL = &H186
Private Declare Function SendMessageByRef Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As Long) As Long
Private Declare Function SendMessageByVal Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Private Sub Form_Load()

    MARGINx2 = MARGIN * 2
    mVertUsedArea = MARGINx2 + pic.Height
    SetLBTabs lst.hwnd, 200    ' "hides" URL in ListBox
    
End Sub

Private Sub Form_Resize()

    On Error Resume Next
    
    lst.Move MARGIN, MARGIN, Me.ScaleWidth - MARGINx2, Me.ScaleHeight - mVertUsedArea
    
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)

    Cancel = (UnloadMode = vbFormControlMenu)
    If Cancel Then cmdCancel_Click
    
End Sub

Private Sub cmdCancel_Click()

    Me.Tag = vbNullString
    Me.Hide     ' <-- Form is loaded for life of WbrFavs program
    
End Sub

Private Sub cmdOK_Click()

    Me.Tag = "OK"
    Me.Hide     ' <-- Form is loaded for life of WbrFavs program
    
End Sub

Private Sub lst_Click()

    lblURL = Split(lst, vbTab)(1)
    cmdOK.Enabled = True
    
End Sub

Private Sub lst_DblClick()

    cmdOK_Click
    
End Sub

Public Sub AddLBEntry(LBEntry As String)

    lst.AddItem LBEntry
    
End Sub

Public Sub ResetSelection()

    SetLBNoSelection LBhWnd:=lst.hwnd
    lblURL = vbNullString
    cmdOK.Enabled = False
    
End Sub

Public Function RemoveDuplicates() As Long   ' Returns number removed

    On Error GoTo RemoveDuplicates_Error
    
    Dim InTotal As Long
    Dim IX As Long
    
    With lst
        InTotal = .ListCount
        For IX = InTotal - 1 To 1 Step -1   ' = reverse order
            If StrComp(.List(IX), .List(IX - 1), vbTextCompare) = 0 Then
                .RemoveItem IX    ' duplicate entry
           End If
        Next
    End With
    
RemoveDuplicates_Exit:
    RemoveDuplicates = InTotal - lst.ListCount
    Exit Function
   
RemoveDuplicates_Error:
    MsgBox Err.Number & ": " & Err.Description, vbExclamation, "RemoveDuplicates"
    Resume RemoveDuplicates_Exit
    
End Function

Private Function SetLBTabs(LBhWnd As Long, ParamArray TabStops()) As Boolean

    On Error GoTo SetLBTabs_Exit
    
    Dim Result As Boolean
    Dim Tabs(0 To 7) As Long    ' Dialog units - approx Pixels*4
    Dim NumOfTabs As Long
    Dim IX As Long
    
    NumOfTabs = UBound(TabStops)
    For IX = 0 To NumOfTabs
        Tabs(IX) = TabStops(IX) * 4
    Next
    NumOfTabs = NumOfTabs + 1
    Result = SendMessageByRef(LBhWnd, LB_SETTABSTOPS, NumOfTabs, Tabs(0))
    
SetLBTabs_Exit:
    SetLBTabs = Result
    
End Function

Private Sub SetLBNoSelection(LBhWnd As Long)
'
' Equivalent to ListBox.ListIndex = -1 without generating ListBox_Click Event
'
    On Error Resume Next

    SendMessageByVal LBhWnd, LB_SETCURSEL, -1, 0

End Sub

